Index: /trunk/src/sh_tools.c
===================================================================
--- /trunk/src/sh_tools.c	(revision 584)
+++ /trunk/src/sh_tools.c	(revision 1)
@@ -70,5 +70,5 @@
 #endif
 #ifndef FD_ZERO
-#define FD_ZERO(p)      memset((char *)(p), 0, sizeof(*(p)))
+#define FD_ZERO(p)      memset((char *)(p), '\0', sizeof(*(p)))
 #endif
 
@@ -77,6 +77,4 @@
 #include <sys/mman.h>
 #endif
-
-#define SH_REAL_SET
 
 #include "samhain.h"
@@ -88,166 +86,53 @@
 #define SH_NEED_GETHOSTBYXXX
 #include "sh_static.h"
-#include "sh_pthread.h"
-#include "sh_ipvx.h"
 
 #undef  FIL__
 #define FIL__  _("sh_tools.c")
 
-static int tools_debug = 0;
-
 #ifdef SH_ENCRYPT
 #include "rijndael-api-fst.h"
-char * errorExplain (int err_num, char * buffer, size_t len)
-{
-  char * p;
-
+char * errorExplain (int err_num)
+{
   if      (err_num == BAD_KEY_DIR)
-    p = (_("Key direction is invalid"));
+    return (_("Key direction is invalid"));
   else if (err_num == BAD_KEY_MAT) 
-    p = (_("Key material not of correct length"));
+    return (_("Key material not of correct length"));
   else if (err_num == BAD_KEY_INSTANCE) 
-    p = (_("Key passed is not valid"));
+    return (_("Key passed is not valid"));
   else if (err_num == BAD_CIPHER_MODE) 
-    p = (_("Params struct passed to rijndael_cipherInit invalid"));
+    return (_("Params struct passed to cipherInit invalid"));
   else if (err_num == BAD_CIPHER_STATE) 
-    p = (_("Cipher in wrong state"));
+    return (_("Cipher in wrong state"));
   else if (err_num == BAD_BLOCK_LENGTH) 
-    p = (_("Bad block length"));
+    return (_("Bad block length"));
   else if (err_num == BAD_CIPHER_INSTANCE) 
-    p = (_("Bad cipher instance"));
+    return (_("Bad cipher instance"));
   else if (err_num == BAD_DATA) 
-    p = (_("Data contents are invalid"));
+    return (_("Data contents are invalid"));
   else  
-    p = (_("Unknown error"));
-  sl_strlcpy (buffer, p, len);
-  return buffer;
-}
-
-#endif
-
-/* --- check for an interface ---
+    return (_("Unknown error"));
+}
+
+#endif
+
+/* --- recode all \blah escapes to '=XX' format, and also code all
+ *     remaining unprintable chars                                 ---
  */
-int sh_tools_iface_is_present(char *str)
-{
-#if defined(USE_IPVX)
-  struct addrinfo *ai;
-  struct addrinfo hints;
-  int             res;
-
-  memset (&hints, 0, sizeof (hints));
-  hints.ai_flags = AI_PASSIVE | AI_ADDRCONFIG;
-  hints.ai_socktype = SOCK_STREAM;
-  res = getaddrinfo (str, _("2543"), &hints, &ai);
-  
-  if (res == 0)
-    {
-      struct addrinfo *p = ai;
-      while (p != NULL)
-	{
-	  int fd = socket (p->ai_family, p->ai_socktype,
-			   p->ai_protocol);
-
-	  if (fd < 0)
-	    {
-	      freeaddrinfo (ai);
-	      return 0;
-	    }
-
-	  if (bind (fd, p->ai_addr, p->ai_addrlen) != 0)
-	    {
-	      /* bind() fails for access reasons, iface exists
-	       */
-	      if (errno == EACCES || errno == EADDRINUSE)
-		{
-		  sl_close_fd (FIL__, __LINE__, fd);
-		  freeaddrinfo (ai);
-		  return 1;
-		}
-
-	      sl_close_fd (FIL__, __LINE__, fd);
-	      freeaddrinfo (ai);
-	      return 0;
-	    }
-
-	  sl_close_fd (FIL__, __LINE__, fd);
-	  freeaddrinfo (ai);
-	  return 1;
-	  /* p = p->ai_next; */ 
-	}
-    }
-#else
-  struct sockaddr_in sin;
-  int sd;
-
-  memset(&sin, 0, sizeof(sin));
-  sin.sin_family = AF_INET;
-  if (inet_aton(str, &(sin.sin_addr)))
-    {
-      sin.sin_port = htons(2543);
-
-      if (-1 == (sd = socket(AF_INET, SOCK_STREAM, 0)))
-	{
-	  /* cppcheck-suppress resourceLeak */
-	  return 0;
-	}
-
-      if (-1 == bind(sd, (struct sockaddr *)&sin, sizeof(sin)))
-	{
-	  int retval = 0;
-
-	  /* bind() fails for access reasons, iface exists
-	   */
-	  if (errno == EACCES || errno == EADDRINUSE)
-	    retval = 1;
-	  sl_close_fd (FIL__, __LINE__, sd);
-	  return retval;
-	}
-
-      /* bind() succeeds, iface exists
-       */
-      sl_close_fd(FIL__, __LINE__, sd);
-      return 1;
-    }
-#endif
-  return 0;
-}
-
-/* --- recode all \blah escapes to qp (quoted printable) '=XX' format, and 
- *     also code all remaining unprintable chars                           ---
- */
-#define SH_PUT_4(p, a, b, c) (p)[0] = (a); (p)[1] = (b); (p)[2] = (c);
-  
 char * sh_tools_safe_name (const char * instr, int flag)
 {
-  unsigned char c, d;
+  unsigned char c;
   const  char * p;
   char   tmp[4];
   char * outstr;
-  size_t len = 1;
+  int    len;
   int    i = 0;
   unsigned char   val_octal = '\0';
-  static char ctable[16] = { '0', '1', '2', '3', '4', '5', '6', '7', 
-			     '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' }; 
 
   SL_ENTER(_("sh_tools_safe_name"));
 
   if (instr)
-    {
-      len = strlen(instr);
-      if (sl_ok_muls (3, len) && sl_ok_adds ((3*len), 4))
-	{
-	  len = (3 * len) + 4;
-	  p = instr;
-	}
-      else
-	{
-	  len = 1;
-	  p   = NULL;
-	}
-    }
+    len = (3 * strlen(instr)) + 4;
   else
-    {
-      p = NULL;
-    }
+    len = 1;
 
   outstr = SH_ALLOC(len);
@@ -256,12 +141,7 @@
   tmp[3]    = '\0';
 
-#if !defined(SH_USE_XML)
-  (void) flag; /* fix compiler warning */
-#endif
-
-  if (!p)
-    goto end;
-
-  while (*p)
+  p = instr;
+
+  while (p && *p)
     {
       c = *p;
@@ -274,53 +154,44 @@
 
 #ifdef SH_USE_XML
-      if (flag == 1)
-	{
-	  if ((*p) == '"')
-	    { 
-	      SH_PUT_4(&outstr[i], '=', '2', '2');
-	      i+=3; ++p;
-	      continue;
-	    } 
-	  else if ((*p) == '&')
-	    { 
-	      SH_PUT_4(&outstr[i], '=', '2', '6');
-	      i+=3; ++p;
-	      continue;
-	    } 
-	  else if ((*p) == '<') 
-	    {     /* left angle       */
-	      SH_PUT_4(&outstr[i], '=', '3', 'c');
-	      i+=3; ++p;
-	      continue;
-	    } 
-	  else if ((*p) == '>') 
-	    {     /* right angle      */
-	      SH_PUT_4(&outstr[i], '=', '3', 'e');
-	      i+=3; ++p;
-	      continue;
-	    }
+      if (flag == 1 && (*p) == '"')
+	{ 
+	  sprintf(&outstr[i], "=%02x", c);   i+=3; ++p;  /* known to fit  */
+	  continue;
+	} 
+      else if (flag == 1 && (*p) == '&')
+	{ 
+	  sprintf(&outstr[i], "=%02x", c);   i+=3; ++p;  /* known to fit  */
+	  continue;
+	} 
+      else if (flag == 1 && (*p) == '<') 
+	{     /* left angle       */
+	  sprintf(&outstr[i], "=%02x", c);   i+=3; ++p;  /* known to fit  */
+	  continue;
+	} 
+      else if (flag == 1 && (*p) == '>') 
+	{     /* right angle      */
+	  sprintf(&outstr[i], "=%02x", c);   i+=3; ++p;  /* known to fit  */
+	  continue;
 	}
+#else
+      (void) flag; /* fix compiler warning */
 #endif
 
       if ( (*p) != '\\' && (*p) != '&' && (*p) != '='  && (*p) != '\'') 
         {
-	  outstr[i] = *p; ++i;
-	  ++p;
-	      
-	  if (c < 32 || c > 126)
+	  if (c < 31 || c > 126)
 	    {
-	      --i;
-	      d = c % 16; c = c / 16;
-	      outstr[i] = '=';       ++i;
-	      outstr[i] = ctable[c]; ++i;
-	      outstr[i] = ctable[d]; ++i;
+	      sprintf(&outstr[i], "=%02x", c); i+=3; ++p;/* known to fit  */
 	    }
-
+	  else
+	    {
+	      outstr[i] = *p;
+	      ++i; ++p;
+	    }
 	  continue;
 	}
       else if ((*p) == '\'')
 	{
-	  SH_PUT_4(&outstr[i], '=', '2', '7');
-	  i+=3; ++p;
+	  sprintf(&outstr[i], "=%02x", c);   i+=3; ++p;  /* known to fit  */
 	}
       else if (*p == '=')
@@ -328,6 +199,5 @@
 	  if (p[1] != '"' && p[1] != '<')
 	    { 
-	      SH_PUT_4(&outstr[i], '=', '3', 'd');
-	      i+=3; ++p;
+	      sprintf(&outstr[i], "=%02x", c); i+=3; ++p;/* known to fit  */
 	    }
 	  else
@@ -342,49 +212,48 @@
 	    break;
 
-
+	  c = *p;
 
 	  switch (*p) {
 	  case '\\':
-	    SH_PUT_4(&outstr[i], '=', '5', 'c');
-	    i+=3; ++p;
+	    sprintf(&outstr[i], "=%02x", c);  i+=3; ++p; /* known to fit  */
 	    break;
 	  case 'n':
-	    SH_PUT_4(&outstr[i], '=', '0', 'a');
+	    sprintf(&outstr[i], "=%02x", '\n');          /* known to fit  */
 	    i+=3; ++p;
 	    break;
 	  case 'b':
-	    SH_PUT_4(&outstr[i], '=', '0', '8');
+	    sprintf(&outstr[i], "=%02x", '\b');          /* known to fit  */
 	    i+=3; ++p;
 	    break;		       
 	  case 'r':		       
-	    SH_PUT_4(&outstr[i], '=', '0', 'd');
+	    sprintf(&outstr[i], "=%02x", '\r');          /* known to fit  */
 	    i+=3; ++p;
 	    break;		       
 	  case 't':		       
-	    SH_PUT_4(&outstr[i], '=', '0', '9');
+	    sprintf(&outstr[i], "=%02x", '\t');          /* known to fit  */
 	    i+=3; ++p;
 	    break;		       
 	  case 'v':		       
-	    SH_PUT_4(&outstr[i], '=', '0', 'b');
+	    sprintf(&outstr[i], "=%02x", '\v');          /* known to fit  */
 	    i+=3; ++p;
 	    break;		       
 	  case 'f':		       
-	    SH_PUT_4(&outstr[i], '=', '0', 'c');
+	    sprintf(&outstr[i], "=%02x", '\f');          /* known to fit  */
 	    i+=3; ++p;
 	    break;		       
 	  case '\'':		       
-	    SH_PUT_4(&outstr[i], '=', '2', '7');
+	    sprintf(&outstr[i], "=%02x", '\'');          /* known to fit  */
 	    i+=3; ++p;
 	    break;		       
-	  case '"':	/* also encode quoted '"' */ 	       
-	    SH_PUT_4(&outstr[i], '=', '2', '2');
+	  case '\"':	/* also encode quoted '"' */ 	       
+	    sprintf(&outstr[i], "=%02x", '\"');          /* known to fit  */
 	    i+=3; ++p;
 	    break;		       
 	  case ' ':		       
-	    SH_PUT_4(&outstr[i], '=', '2', '0');
+	    sprintf(&outstr[i], "=%02x", ' ');           /* known to fit  */
 	    i+=3; ++p;
 	    break;
 	  default:
-	    if (strlen(p) < 3) /* certainly not an octal number, skip */
+	    if (strlen(p) < 3)
 	      {
 		p += strlen(p);
@@ -396,8 +265,6 @@
 		if (val_octal != '\0') { 
 		  c = val_octal;
-		  d = c % 16; c = c / 16;
-		  outstr[i] = '=';       ++i;
-		  outstr[i] = ctable[c]; ++i;
-		  outstr[i] = ctable[d]; ++i;
+		  sprintf(&outstr[i], "=%02x", c);       /* known to fit  */
+		  i+=3;
 		} 
 		p += 3;
@@ -405,16 +272,13 @@
 	  }
 	}
-      else if (*p == '&')
+      else /* *p == '&' */
 	{
 	  ++p;
-	  if (!p || !(*p))
-	    {
-	      outstr[i] = '&'; ++i;
-	      break;
-	    }
+	  if (!p || !(*p)) 
+	    break;
 
 	  if (p[0] == 'a' && p[1] == 'm' && p[2] == 'p' && p[3] == ';')
 	    {
-	      SH_PUT_4(&outstr[i], '=', '2', '6');
+	      sprintf(&outstr[i], "=%02x", '&');         /* known to fit  */
 	      i+=3; p += 4;
 	    }
@@ -422,15 +286,15 @@
 		   p[4] == ';')
 	    {
-	      SH_PUT_4(&outstr[i], '=', '2', '2');
+	      sprintf(&outstr[i], "=%02x", '"');         /* known to fit  */
 	      i+=3; p += 5;
 	    }
 	  else if (p[0] == 'l' && p[1] == 't' && p[2] == ';')
 	    {
-	      SH_PUT_4(&outstr[i], '=', '3', 'c');
+	      sprintf(&outstr[i], "=%02x", '<');         /* known to fit  */
 	      i+=3; p += 3;
 	    }
 	  else if (p[0] == 'g' && p[1] == 't' && p[2] == ';')
 	    {
-	      SH_PUT_4(&outstr[i], '=', '3', 'e');
+	      sprintf(&outstr[i], "=%02x", '>');         /* known to fit  */
 	      i+=3; p += 3;
 	    }
@@ -439,13 +303,6 @@
 	      outstr[i] = '&'; ++i;
 	    }
-	}
-      else
-	{
-	  outstr[i] = *p; ++i;
-	  ++p;
-	}
+	}     
     } /* while (p && *p) */
-
- end:
   
   outstr[i] = '\0';
@@ -456,26 +313,35 @@
 /* extern int h_errno; */ 
 
-char * sh_tools_errmessage (int tellme, char * errbuf, size_t len)
-{
-  char * p = NULL;
+char * sh_tools_errmessage (int tellme)
+{
+
 #ifdef HOST_NOT_FOUND
     if (tellme == HOST_NOT_FOUND)  
-      p = _("The specified host is unknown: ");
+      return _("The specified host is unknown: ");
 #endif
 #ifdef NO_ADDRESS
     if (tellme == NO_ADDRESS)  
-      p = _("The requested name is valid but does not have an IP address: ");
+      return _("The requested name is valid but does not have an IP address: ");
 #endif
 #ifdef NO_RECOVERY
     if (tellme == NO_RECOVERY)  
-      p = _("A non-recoverable name server error occurred: ");
+      return _("A non-recoverable name server error occurred: ");
 #endif
 #ifdef TRY_AGAIN
     if (tellme == TRY_AGAIN)  
-      p = _("A temporary error occurred on an authoritative name server. The specified host is unknown: ");
-#endif
-    if (!p) p =  _("Unknown error");
-    sl_strlcpy(errbuf, p, len);
-    return errbuf;
+      return _("A temporary error occurred on an authoritative name server. The specified host is unknown: ");
+#endif
+    return _("Unknown error");
+}
+
+int is_numeric (const char * address)
+{
+  int j;
+  int len = sl_strlen(address);
+  
+  for (j = 0; j < len; ++j)
+    if ( (address[j] < '0' || address[j] > '9') && address[j] != '.')
+      return (1 == 0);
+  return (1 == 1);
 }
 
@@ -509,5 +375,5 @@
 typedef struct _sin_cache {
   char * address;
-  struct sh_sockaddr  saddr;
+  struct sockaddr_in sin;
   struct _sin_cache * next;
 } sin_cache;
@@ -519,5 +385,5 @@
 {
   sin_cache * check_cache = conn_cache;
-  sin_cache * old_entry;
+  sin_cache * old_entry   = conn_cache;
 
   SL_ENTER(_("delete_cache"));
@@ -539,10 +405,9 @@
 int DoReverseLookup = S_TRUE;
 
-int set_reverse_lookup (const char * c)
+int set_reverse_lookup (char * c)
 {
   return sh_util_flagval(c, &DoReverseLookup);
 }
 
-#if !defined(USE_IPVX)
 int connect_port (char * address, int port, 
 		  char * ecall, int * errnum, char * errmsg, int errsiz)
@@ -555,20 +420,14 @@
   char   * host_name;
 
-  volatile int    fd = (-1);
+  int    fd = (-1);
   int    status;
-  volatile int    fail   = 0;
+  int    fail   = 0;
   int    cached = 0;
 
   int    retval;
-  char   errbuf[SH_ERRBUF_SIZE];
 
   sin_cache * check_cache = conn_cache;
 
   SL_ENTER(_("connect_port"));
-
-  if (tools_debug)
-    fprintf(stderr, _("-00- <%s> <%d> no IPv6 support\n"), address, port);
-
-  if (errsiz > 0) errmsg[0] = '\0';
 
   /* paranoia -- should not happen
@@ -581,26 +440,12 @@
       while (check_cache && check_cache->address)
 	{
-          if (tools_debug)
-            fprintf(stderr, _("-01- <%s> <%s>\n"), 
-                    address, check_cache->address);
-
 	  if ( 0 == sl_strncmp(check_cache->address, 
-			       address, sl_strlen(address)) )
+			       address, sl_strlen(address)))
 	    {
-	      memcpy (&sinr, &((check_cache->saddr).sin), sizeof(struct sockaddr_in));
+	      memcpy (&sinr, &(check_cache->sin), sizeof(struct sockaddr_in));
 	      sinr.sin_family = AF_INET;
 	      sinr.sin_port   = htons (port);
 	      cached = 1;
 	      break;
-	    }
-	  if (tools_debug)
-	    {
-	      char eaddr[SH_IP_BUF];
-	      sl_strlcpy(eaddr, 
-			 inet_ntoa(*(struct in_addr *) &(sinr.sin_addr)), 
-			 sizeof(eaddr));
-	      fprintf(stderr, _("-02- <AF_INET> <%s> <%d> <%d>\n"), 
-		      eaddr,
-		      port, cached);
 	    }
 	  if (check_cache->next)
@@ -615,6 +460,4 @@
   if (cached == 0)
     {
-      if (tools_debug)
-        fputs(_("-03- not cached\n"), stderr); 
 #ifdef HAVE_INET_ATON
       if (0 == inet_aton(address, &haddr))
@@ -623,8 +466,5 @@
 #endif
 	{
-	  SH_MUTEX_LOCK(mutex_resolv);
-
-	  host_name = NULL;
-
+      
 	  host_entry = sh_gethostbyname(address);
 
@@ -637,5 +477,5 @@
 	      *errnum = 666;
 #endif
-	      (void) sh_tools_errmessage (*errnum, errmsg, errsiz);
+	      sl_strlcpy(errmsg, sh_tools_errmessage (*errnum), errsiz);
 	      sl_strlcat(errmsg, address, errsiz); 
 	      fail = (-1);
@@ -647,11 +487,4 @@
 	      sinr.sin_addr   = *(struct in_addr *) host_entry->h_addr;
 
-	      if (tools_debug)
-                fprintf(stderr, 
-			_("-04- <%s> <%s> hostent->h_name %s <%s> hostent->h_addr\n"), 
-                        address, 
-			(host_entry->h_name == NULL) ? _("NULL") : host_entry->h_name,
-			(host_entry->h_addrtype == AF_INET) ? _("AF_INET") : _("AF_INET6"),
-			inet_ntoa(*(struct in_addr *) &(sinr.sin_addr)));
 
 	      /* reverse DNS lookup
@@ -666,5 +499,10 @@
 		  else
 		    {
-		      host_name = sh_util_strdup(host_entry->h_name);
+		      host_name = SH_ALLOC(sl_strlen(host_entry->h_name) + 1);
+		      if (sl_strlen(host_entry->h_name) > 0)
+			strcpy(host_name,                /* known to fit  */
+			       host_entry->h_name);
+		      else
+			host_name[0] = '\0';
 		    }
 
@@ -680,5 +518,6 @@
 		      *errnum = 666;
 #endif
-		      (void) sh_tools_errmessage (*errnum, errmsg, errsiz);
+		      sl_strlcpy(errmsg, 
+				 sh_tools_errmessage (*errnum), errsiz);
 		      sl_strlcat(errmsg, 
 				 inet_ntoa (*(struct in_addr *) &(sinr.sin_addr)),
@@ -690,5 +529,5 @@
 		      *errnum = 0;
 		      if (sl_strlen(host_entry->h_name) == 0 || 
-			  (*errnum = sl_strcasecmp(host_name,host_entry->h_name)) != 0)
+			  (*errnum = sl_strcmp(host_name,host_entry->h_name)) != 0)
 			{ 
 			  if (*errnum)
@@ -696,5 +535,5 @@
 			  else
 			    sl_strlcpy(ecall, _("strlen"), SH_MINIBUF);
-			  sl_strlcpy(errmsg, _("Reverse lookup failed: "), 
+			  sl_strlcpy(errmsg, _("Reverse lookup failed."), 
 				     errsiz);
 			  sl_strlcat(errmsg, address, errsiz);
@@ -706,8 +545,8 @@
 			}
 		    }
+
+		  SH_FREE(host_name);
 		}
 	    }
-	  SH_MUTEX_UNLOCK(mutex_resolv);
-	  if (host_name) SH_FREE(host_name);
 	}
   
@@ -717,10 +556,4 @@
 	  sinr.sin_port   = htons (port);
 	  sinr.sin_addr   = haddr;
-
-	  if (tools_debug)
-	    fprintf(stderr, 
-		    _("-04- <%s> is_numeric AF_INET <%s> \n"), 
-		    address, 
-		    inet_ntoa(*(struct in_addr *) &(sinr.sin_addr)));
 	}
 
@@ -733,7 +566,5 @@
 	  check_cache->address = SH_ALLOC(sl_strlen(address) + 1);
 	  sl_strlcpy (check_cache->address, address, sl_strlen(address) + 1);
-
-	  sh_ipvx_save(&(check_cache->saddr), AF_INET, (struct sockaddr *) &sinr);
-
+	  memcpy(&(check_cache->sin), &sinr, sizeof(struct sockaddr_in));
 	  ++cached_addr;
 	  
@@ -763,5 +594,5 @@
 	sl_strlcpy(ecall, _("socket"), SH_MINIBUF);
 	*errnum = status;
-	sl_strlcpy(errmsg, sh_error_message (status, errbuf, sizeof(errbuf)), errsiz);
+	sl_strlcpy(errmsg, sh_error_message (status), errsiz);
 	sl_strlcat(errmsg, _(", address "), errsiz);
 	sl_strlcat(errmsg, address, errsiz);
@@ -777,11 +608,8 @@
 	sl_strlcpy(ecall, _("connect"), SH_MINIBUF);
 	*errnum = status;
-	sl_strlcpy(errmsg, sh_error_message (status, errbuf, sizeof(errbuf)), errsiz);
-	sl_strlcat(errmsg, 
-		   (sinr.sin_family == AF_INET) ? _(", AF_INET ") : _(", AF_INET6 "),
-		   errsiz);
+	sl_strlcpy(errmsg, sh_error_message (status), errsiz);
 	sl_strlcat(errmsg, _(", address "), errsiz);
 	sl_strlcat(errmsg, address, errsiz);
-	sl_close_fd(FIL__, __LINE__, fd);
+	close(fd);
 	fail = (-1); 
       }
@@ -791,291 +619,4 @@
   SL_RETURN(retval, _("connect_port"));
 }
-#else
-int connect_port (char * address, int port, 
-		  char * ecall, int * errnum, char * errmsg, int errsiz)
-{
-  struct sockaddr_in *sin;
-  struct sockaddr_in6 *sin6;
-  struct sh_sockaddr ss;
-  sin_cache * check_cache = conn_cache;
-  int    cached = 0;
-  int    fail   = 0;
-  int    fd     = -1;
-  int    status = 0;
-
-  int    retval;
-  char   errbuf[SH_ERRBUF_SIZE];
-
-  SL_ENTER(_("connect_port"));
-
-  /* paranoia -- should not happen
-   */
-  if (cached_addr > 128)
-    delete_cache();
-
-  if (tools_debug)
-    fprintf(stderr, _("-00- <%s> <%d>\n"), address, port);
-
-  if (check_cache != NULL)
-    {
-      while (check_cache && check_cache->address)
-	{
-	  if (tools_debug)
-	    fprintf(stderr, _("-01- <%s> <%s>\n"), 
-		    address, check_cache->address);
-
-	  if ( 0 == sl_strcmp(check_cache->address, address) )
-	    {
-	      memcpy (&ss, &(check_cache->saddr), sizeof(struct sh_sockaddr));
-	      switch (ss.ss_family) 
-		{
-		case AF_INET:
-		  sin = &(ss.sin);
-		  sin->sin_port   = htons (port);
-		  cached = 1;
-		  break;
-		case AF_INET6:
-		  sin6 = &(ss.sin6);
-		  sin6->sin6_port  = htons (port);
-		  cached = 1;
-		  break;
-		default:
-		  break;
-		}
-	      if (tools_debug)
-		{
-		  char eaddr[SH_IP_BUF];
-		  sh_ipvx_ntoa(eaddr, sizeof(eaddr), &ss);
-		  fprintf(stderr, _("-02- <%s> <%s> <%d> <%d>\n"), 
-			  (ss.ss_family == AF_INET) ? _("AF_INET") : _("AF_INET6"),
-			  eaddr,
-			  port, cached);
-		}
-	      break;
-	    }
-	  if (check_cache->next)
-	    check_cache = check_cache->next;
-	  else
-	    check_cache = NULL;
-	}
-    }
-
-  if (cached != 0)
-    {
-      if (tools_debug)
-	fputs(_("-03- cached\n"), stderr); 
-      /* cppcheck-suppress uninitStructMember */
-      fd = socket(ss.ss_family, SOCK_STREAM, 0);
-      if (fd < 0) 
-	{
-	  status = errno;
-	  fail   = (-1);
-	  sl_strlcpy(ecall, _("socket"), SH_MINIBUF);
-	  *errnum = status;
-	  sl_strlcpy(errmsg, sh_error_message (status, errbuf, sizeof(errbuf)), errsiz);
-	  sl_strlcat(errmsg, _(", address "), errsiz);
-	  sl_strlcat(errmsg, address, errsiz);
-	}
-
-
-      if (fail != (-1)) 
-	{
-	  /* cppcheck-suppress uninitStructMember */
-	  int addrlen = SH_SS_LEN(ss);
-
-	  if ( retry_connect(FIL__, __LINE__, fd, 
-			     sh_ipvx_sockaddr_cast(&ss), addrlen) < 0) 
-	    {
-	      status = errno;
-	      sl_strlcpy(ecall, _("connect"), SH_MINIBUF);
-	      *errnum = status;
-	      sl_strlcpy(errmsg, sh_error_message (status, errbuf, sizeof(errbuf)), errsiz);
-	      sl_strlcat(errmsg, _(", address "), errsiz);
-	      sl_strlcat(errmsg, address, errsiz);
-	      sl_close_fd(FIL__, __LINE__, fd);
-	      fail = (-1); 
-	    }
-	}
-
-      if (fail != 0)
-	{
-	  delete_cache();
-	  cached = 0;
-	}
-    }
-
-  if (cached == 0)
-    {
-      int    res;
-      char   sport[32];
-      struct addrinfo *ai;
-      struct addrinfo hints;
-
-      if (tools_debug)
-	fputs(_("-03- not cached\n"), stderr);
-
-      memset (&hints, 0, sizeof (hints));
-      hints.ai_flags = AI_ADDRCONFIG;
-#if defined(AI_CANONNAME)
-      hints.ai_flags |= AI_CANONNAME;
-#endif 
-      hints.ai_family   = AF_UNSPEC;
-      hints.ai_socktype = SOCK_STREAM;
-      sl_snprintf(sport, sizeof(sport), "%d", port);
-
-      res = getaddrinfo (address, sport, &hints, &ai);
-      if (res != 0)
-	{
-	  fail = (-1);
-	  status = errno;
-	  sl_strlcpy(ecall, _("getaddrinfo"), SH_MINIBUF);
-	  *errnum = status;
-	  sl_strlcpy(errmsg, gai_strerror (res), errsiz);
-	  sl_strlcat(errmsg, _(", address "), errsiz);
-	  sl_strlcat(errmsg, address, errsiz);
-	}
-
-      if (fail != (-1) && (DoReverseLookup == S_TRUE) && !sh_ipvx_is_numeric(address))
-	{
-	  struct addrinfo *p = ai;
-	  int    success = 0;
-	  char hostname[SH_BUFSIZE];
-	  const char * canonical;
-
-
-#if defined(AI_CANONNAME)
-	  if (ai->ai_canonname && strlen(ai->ai_canonname) > 0)
-	    {
-	      canonical = ai->ai_canonname;
-	      if (tools_debug)
-		fprintf(stderr, _("-04- <%s> <%s> ai->ai_canonname\n"), 
-			address, canonical);
-	    }
-	  else
-	    {
-	      canonical = address;
-	      if (tools_debug)
-		fprintf(stderr, _("-04- <%s> <%s> defined ai_canonname\n"), 
-			address, canonical);
-	    }
-#else
-	  canonical = address;
-	  if (tools_debug)
-	    fprintf(stderr, _("-04- <%s> <%s> not defined ai_canonname\n"), 
-		    address, canonical);
-#endif
-
-	  while (p != NULL)
-	    {
-	      int e = getnameinfo (p->ai_addr, p->ai_addrlen, 
-				   hostname, sizeof(hostname),
-				   NULL, 0, NI_NAMEREQD);
-	      
-	      if (e == 0)
-		{
-		  if (tools_debug)
-		    {
-		      fprintf(stderr, _("-05- <%s> <%s> <%s>\n"), 
-			      (p->ai_family == AF_INET) ? _("AF_INET") : _("AF_INET6"),
-			      sh_ipvx_print_sockaddr (p->ai_addr, p->ai_family),
-			      hostname);
-		    }
-
-		  if (sl_strcasecmp(hostname, canonical) == 0)
-		    {
-		      if (tools_debug)
-			fprintf(stderr, _("-06- <%s> <%s> match\n"), 
-				hostname, canonical);
-		      success = 1;
-		      break;
-		    }
-
-		}
-	    
-	      p = p->ai_next;
-	    }
-
-	  if (success == 0)
-	    {
-	      sl_strlcpy(ecall, _("strcmp"), SH_MINIBUF);
-	      sl_strlcpy(errmsg, _("Reverse lookup failed: "), 
-			 errsiz);
-	      sl_strlcat(errmsg, address, errsiz);
-	      fail = -1;
-	      freeaddrinfo (ai);
-	    }
-	}
-
-      if (fail != (-1))
-	{
-	  struct addrinfo *p = ai;
-
-	  while (p != NULL)
-	    {
-	      if ( (SOCK_STREAM == p->ai_socktype) &&
-		   ((p->ai_family == AF_INET) || (p->ai_family == AF_INET6)) )
-		{
-		
-		  fd = socket(p->ai_family, SOCK_STREAM, 0);
-		  
-		  if (fd != (-1))
-		    {
-		      if (retry_connect(FIL__, __LINE__, fd, 
-					p->ai_addr, p->ai_addrlen) >= 0)
-			{
-			  /* put it into the cache
-			   */
-			  check_cache          = SH_ALLOC(sizeof(sin_cache));
-			  check_cache->address = SH_ALLOC(sl_strlen(address) + 1);
-			  sl_strlcpy (check_cache->address, address, sl_strlen(address) + 1);
-			  
-			  sh_ipvx_save(&(check_cache->saddr), p->ai_family, p->ai_addr);
-			  
-			  ++cached_addr;
-			  
-			  if (conn_cache)
-			    {
-			      if (conn_cache->next)
-				check_cache->next    = conn_cache->next;
-			      else
-				check_cache->next    = NULL;
-			      conn_cache->next     = check_cache;
-			    }
-			  else
-			    {
-			      check_cache->next    = NULL;
-			      conn_cache           = check_cache;
-			    }
-			  
-			  freeaddrinfo (ai);
-			  goto end;
-			}
-		      status = errno;
-		      sl_close_fd(FIL__, __LINE__, fd);
-		    }
-		  else
-		    {
-		      status = errno;
-		    }
-		}
-	      p = p->ai_next;
-	    }
-	  fail = (-1);
-	  freeaddrinfo (ai);
-
-	  sl_strlcpy(ecall, _("connect"), SH_MINIBUF);
-	  *errnum = status;
-	  sl_strlcpy(errmsg, sh_error_message (status, errbuf, sizeof(errbuf)), errsiz);
-	  sl_strlcat(errmsg, _(", address "), errsiz);
-	  sl_strlcat(errmsg, address, errsiz);
-	}
-    }
-
- end:
-  retval = (fail < 0) ? (-1) : fd;
-  SL_RETURN(retval, _("connect_port"));
-
-}
-#endif
 
 int connect_port_2 (char * address1, char * address2, int port, 
@@ -1117,5 +658,5 @@
 }
 
-#if defined(HAVE_NTIME) || defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
+#if defined(HAVE_NTIME) || defined(SH_WITH_CLIENT)
 static
 int sh_write_select(int type, int sockfd, 
@@ -1129,8 +670,14 @@
   int    num_sel;
   
-  char    errbuf[SH_ERRBUF_SIZE];
+  struct  sigaction  new_act;
+  struct  sigaction  old_act;
 
   SL_ENTER(_("sh_write_select"));
 
+  /* ignore SIGPIPE (instead get EPIPE if connection is closed)
+   */
+  new_act.sa_handler = SIG_IGN;
+  sigaction (SIGPIPE, &new_act, &old_act);
+  
   FD_ZERO(&fds);
   FD_SET(sockfd, &fds);
@@ -1157,13 +704,10 @@
 		continue;
 	      }
-	    if ( errno == EINTR || errno == EINPROGRESS ) /* try again */
+	    if ( errno == EINTR) /* try again */
 	      continue;
 	    *w_error = errno;
-
-	    sh_error_message(*w_error, errbuf, sizeof(errbuf));
-	    sh_error_handle (SH_ERR_INFO, FIL__, __LINE__, errno, MSG_E_SUBGEN,
-			     errbuf,
-			     _("sh_write_select (ws)") ); 
-	    TPT(( 0, FIL__, __LINE__, _("msg=<select: %s>\n"), errbuf ));
+	    TPT(( 0, FIL__, __LINE__, _("msg=<select: %s>\n"), 
+		  sh_error_message(*w_error)));
+	    sigaction (SIGPIPE, &old_act, NULL);
 	    SL_RETURN( countbytes, _("sh_write_select"));
 	  }
@@ -1178,13 +722,10 @@
 		continue;
 	      }
-	    if ( errno == EINTR || errno == EINPROGRESS ) /* try again */
+	    if ( errno == EINTR ) /* try again */
 	      continue;
 	    *w_error = errno;
-
-	    sh_error_message(*w_error, errbuf, sizeof(errbuf));
-	    sh_error_handle (SH_ERR_INFO, FIL__, __LINE__, errno, MSG_E_SUBGEN,
-			     errbuf,
-			     _("sh_write_select (rs)") ); 
-	    TPT(( 0, FIL__, __LINE__, _("msg=<select: %s>\n"), errbuf ));
+	    TPT(( 0, FIL__, __LINE__, _("msg=<select: %s>\n"), 
+		  sh_error_message(*w_error)));
+	    sigaction (SIGPIPE, &old_act, NULL);
 	    SL_RETURN( countbytes, _("sh_write_select"));
 	  }
@@ -1210,5 +751,5 @@
 	    *w_error = 0;
 #endif
-
+	    sigaction (SIGPIPE, &old_act, NULL);
 	    TPT(( 0, FIL__, __LINE__, _("msg=<Timeout>\n")));
 	    SL_RETURN( countbytes, _("sh_write_select"));
@@ -1236,10 +777,5 @@
 	  {
 	    *w_error = errno;
-
-	    sh_error_message(*w_error, errbuf, sizeof(errbuf));
-	    sh_error_handle (SH_ERR_INFO, FIL__, __LINE__, errno, MSG_E_SUBGEN,
-			     errbuf,
-			     (type == SH_DO_WRITE) ? 
-			     _("sh_write_select (w)") : _("sh_write_select (r)")); 
+	    sigaction (SIGPIPE, &old_act, NULL);
 	    TPT(( 0, FIL__, __LINE__, _("msg=<count < 0>\n")));
 	    SL_RETURN( countbytes, _("sh_write_select"));
@@ -1248,5 +784,5 @@
 	  {
 	    *w_error = errno;
-
+	    sigaction (SIGPIPE, &old_act, NULL);
 	    TPT(( 0, FIL__, __LINE__, _("msg=<count == 0>\n")));
 	    SL_RETURN( countbytes, _("sh_write_select"));
@@ -1255,4 +791,9 @@
   }
 
+
+  /* restore signal handler
+   */
+  sigaction (SIGPIPE, &old_act, NULL);
+
   *w_error = 0;
 
@@ -1262,9 +803,10 @@
 #endif
 
-#if defined (SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
+#if defined (SH_WITH_CLIENT)
 unsigned long write_port (int sockfd, char *buf, unsigned long nbytes, 
 			  int * w_error, int timeout)
 {
   unsigned long bytes;
+  char errmsg[256];
 
   SL_ENTER(_("write_port"));
@@ -1273,8 +815,7 @@
   if (*w_error != 0)
     {
-      char errbuf[SH_ERRBUF_SIZE];
+      sl_strlcpy(errmsg, sh_error_message (*w_error), sizeof(errmsg));
       sh_error_handle((-1), FIL__, __LINE__, *w_error, MSG_TCP_NETRP, 
-		      sh_error_message (*w_error, errbuf, sizeof(errbuf)),
-		      (long) sockfd, _("write_port"));
+		      errmsg, (long) sockfd, _("write_port"));
     }
   SL_RETURN( bytes, _("write_port"));
@@ -1282,5 +823,5 @@
 #endif
 
-#if defined(HAVE_NTIME) || defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
+#if defined(HAVE_NTIME) || defined(SH_WITH_CLIENT)
 
 unsigned long read_port (int sockfd, char *buf, unsigned long nbytes, 
@@ -1288,4 +829,5 @@
 {
   unsigned long bytes;
+  char errmsg[256];
 
   SL_ENTER(_("read_port"));
@@ -1294,8 +836,7 @@
   if (*w_error != 0)
     {
-      char errbuf[SH_ERRBUF_SIZE];
+      sl_strlcpy(errmsg, sh_error_message (*w_error), sizeof(errmsg));
       sh_error_handle((-1), FIL__, __LINE__, *w_error, MSG_TCP_NETRP, 
-		      sh_error_message (*w_error, errbuf, sizeof(errbuf)),
-		      (long) sockfd, _("read_port"));
+		      errmsg, (long) sockfd, _("read_port"));
     }
   SL_RETURN( bytes, _("read_port"));
@@ -1318,5 +859,5 @@
 #endif
 
-#if defined (SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
+#if defined (SH_WITH_CLIENT)
 
 int check_request (char * have, char * need)
@@ -1372,95 +913,9 @@
 #endif
 
-#if defined (SH_WITH_CLIENT) || defined (SH_WITH_SERVER)
-
 #if defined (SH_WITH_CLIENT)
 
-static int           probe_done = S_FALSE;
-static unsigned char probe_flag = '\0';
-
-void sh_tools_probe_reset()
-{
-  probe_done = S_FALSE;
-  probe_flag = '\0';
-  return;
-}
-
-#ifdef SH_ENCRYPT
-static int probe_ok(int flag)
-{
-  (void) flag;
-  if ((probe_flag & SH_PROTO_IVA) != 0)
-    return S_TRUE;
-  return S_FALSE;
-}
-#endif
-
-static unsigned char probe_header_set(unsigned char protocol)
-{
-  if (probe_done || (protocol & SH_PROTO_SRP) == 0)
-    return 0;
-
-  return (char) SH_PROTO_IVA;
-}
-
-static void probe_header_get(unsigned char protocol)
-{
-  if (probe_done || (protocol & SH_PROTO_SRP) == 0)
-    return;
-
-  /* If the server doesn't know about it,
-   * it will simply mirror it back. */
-  
-  if ((protocol & SH_PROTO_IVA) != 0)
-    {
-      /* probe was mirrored */;
-    }
-  else
-    {
-      /* probe was UNset */
-      probe_flag |= SH_PROTO_IVA;
-    }
-  probe_done = S_TRUE;
-  return;
-}
-
-#else
-static unsigned char probe_header_set(unsigned char protocol) { 
-  (void) protocol; return 0; }
-static void probe_header_get(unsigned char protocol) { 
-  (void) protocol; return; }
-void sh_tools_probe_reset() { return; }
-
-unsigned char sh_tools_probe_store(unsigned char protocol, int * probe_flag)
-{
-  if ((protocol & SH_PROTO_SRP) == 0)
-    return protocol;
-
-  if ((protocol & SH_PROTO_IVA) != 0)
-    {
-      /* probe received */
-      *probe_flag |=  SH_PROTO_IVA;
-      protocol    &= ~SH_PROTO_IVA;
-    }
-  return protocol; 
-}
-
-#ifdef SH_ENCRYPT
-static int probe_ok(int flag)
-{
-  if ((flag & SH_PROTO_IVA) != 0)
-    return S_TRUE;
-  return S_FALSE;
-}
-#endif
-
-#endif
-
-
 void get_header (unsigned char * head, unsigned long * bytes, char * u)
 {
   SL_ENTER(_("get_header"));
-
-  probe_header_get(head[0]);
 
   *bytes = 
@@ -1482,5 +937,5 @@
 #if defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
 
-#ifdef  SH_ENCRYPT
+#ifdef  SH_ENCRYPT_2
 #define TRANS_BYTES 65120
 #else
